/*   **********************************************************************  **
 **   Copyright notice                                                       **
 **                                                                          **
 **   (c) 2009, Around(J2)ME				                                 **
 **   All rights reserved.                                                   **
 **                                                                          **
 **   This program and the accompanying materials are made available under   **
 **   the terms of the New BSD License which accompanies this    			 **
 **   distribution.											                 **
 **   A copy is found in the textfile LICENSE.txt							 **
 **                                                                          **
 **   This copyright notice MUST APPEAR in all copies of the file!           **
 **                                                                          **
 **   Main developers:                                                       **
 **     Juri Strumpflohner		http://blog.js-development.com	             **
 **		Matthias Braunhofer		http://matthias.jimdo.com                    **
 **                                                                          **
 **  **********************************************************************  */

package com.aroundj2me.main;

import javax.microedition.lcdui.Display;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.aroundj2me.controller.ApplicationController;
import com.aroundj2me.location.LocationService;
import com.aroundj2me.model.Constants;
import com.aroundj2me.utility.AlertCreator;
import com.aroundj2me.view.SplashScreen;

public class AroundJ2ME extends MIDlet {
	private static AroundJ2ME instance = null;
	private ApplicationController applicationController = null;
	private Display display = null;
	private boolean isInitialized;
	
	protected void destroyApp(boolean unconditional)
			throws MIDletStateChangeException {
		
	}

	protected void pauseApp() {
		
	}

	protected void startApp() throws MIDletStateChangeException {
		if (!isInitialized) {
			if(this.display == null) 
				this.display = Display.getDisplay(this);
			
			if(instance == null)
				instance = this;
			
			doStartup();
			
			isInitialized = true;
		}
	}
	
	public void doStartup(){
		applicationController = new ApplicationController(this);
		Thread thread = new Thread() {
			public void run() {
				applicationController.init();
				SplashScreen splashScreen = new SplashScreen(display, applicationController.getNavList());
				display.setCurrent(splashScreen);
				
				LocationService locationService = new LocationService(Constants.LANDMARK_STORE_NAME);
				try {
					locationService.init();
				} catch (Exception e) {
					AlertCreator.getErrorAlert("An error occurred during startup. The application may not work correctly!");
				}
				applicationController.setLocationService(locationService);
				
				splashScreen.dismiss();
				splashScreen = null;
			}
		};
		thread.start();
	}
	
	public Display getDisplay(){
		return this.display;
	}
	
	/**
	 * returns the Singleton instance of the application MIDLet
	 * @return
	 */
	public static AroundJ2ME getInstance(){
		return instance;
	}

}
