/*   **********************************************************************  **
 **   Copyright notice                                                       **
 **                                                                          **
 **   (c) 2009, Around(J2)ME				                                 **
 **   All rights reserved.                                                   **
 **                                                                          **
 **   This program and the accompanying materials are made available under   **
 **   the terms of the New BSD License which accompanies this    			 **
 **   distribution.											                 **
 **   A copy is found in the textfile LICENSE.txt							 **
 **                                                                          **
 **   This copyright notice MUST APPEAR in all copies of the file!           **
 **                                                                          **
 **   Main developers:                                                       **
 **     Juri Strumpflohner		http://blog.js-development.com	             **
 **		Matthias Braunhofer		http://matthias.jimdo.com                    **
 **                                                                          **
 **  **********************************************************************  */

package com.aroundj2me.model;


/**
 * Abstract class that works as Listener for instances of {@link ExecutableTask} processing
 *
 */
public abstract class TaskProcessListener {
	/**
	 * Gets invoked when the {@link ExecutableTask} finishes processing
	 * @param result the resulting object from the computation
	 */
	public abstract void taskFinished(Object result);
	
	/**
	 * Gets invoked when an error occurs during processing
	 * @param status the status message containing information about the error
	 */
	public abstract void onError(String status);
}
